searchData={"items":[{"type":"module","title":"Whenwhere","doc":"A small utility for fetching data from a Whenwhere server.\n\nThe primary task of Whenwhere is to get the rough time.\nA more reliable and resilient option to NTP.\n\nAs a bonus and due to cheap AWS functionality it also includes some GeoIP\nfunctionality. Best effort information about the location of the device.\n\nYou can set up your own using the information\n[available here](https://github.com/nerves-networking/whenwhere).\nIf you do set one up and are willing to share it, let us know.","ref":"Whenwhere.html"},{"type":"function","title":"Whenwhere.ask/1","doc":"This function requests whenwhere data over plain HTTP by default.\nIf switched to https:// it will attempt to verify CA and all that good stuff.\nThe convenient way to do HTTPS is with `asks/0`.\n\nThe reason to use plain HTTP is that it will work for embedded devices\nthat are out of whack with their clock.\n\nA nonce is generated and sent to the server to prevent captive portals\nfrom tricking the device, bust caches and generally increase the likelihood\nthat we are talking to the right server.","ref":"Whenwhere.html#ask/1"},{"type":"function","title":"Whenwhere.asks/0","doc":"Attempts to fetch whenwhere data with HTTPS, so with TLS encryption and CA-checking.\n\nSee `ask/1` for more detail.","ref":"Whenwhere.html#asks/0"},{"type":"function","title":"Whenwhere.https_verify/0","doc":"","ref":"Whenwhere.html#https_verify/0"},{"type":"extras","title":"Whenwhere","doc":"# Whenwhere\n\nA small utility for fetching data from a Whenwhere server.\n\nThe primary task of Whenwhere is to get the rough time.\nA more reliable and resilient option to NTP.\n\nAs a bonus and due to cheap AWS functionality it also includes some GeoIP\nfunctionality. Best effort information about the location of the device.\n\nYou can set up your own using the information\n[available here](https://github.com/nerves-networking/whenwhere).\nIf you do set one up and are willing to share it, let us know.","ref":"readme.html"},{"type":"extras","title":"Installation - Whenwhere","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `whenwhere` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:whenwhere, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Whenwhere","doc":"```elixir\n# Secure\nWhenwhere.asks()\n# Without SSL, no security, but works if your clock is borked\nWhenwhere.ask()\n```\n\nTypical response:\n\n```elixir\n{:ok,\n %{\n   extra: %{\"country\" => \"SE\"},\n   now: ~U[2024-07-15 09:18:14.620Z],\n   address: \"REDACTED_IP:REDACTED_PORT\",\n   time_zone: \"Europe/Stockholm\",\n   city: \"Gothenburg\",\n   country_region: \"O\",\n   # Not redacted because this is an endpoint in Gothenburg, a nearby city, not where I live :D\n   latitude: 57.7065,\n   longitude: 11.967\n }}\n```","ref":"readme.html#usage"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}